
#pragma lib "libxml.a"

typedef struct Xml Xml;
typedef struct Attr Attr;
typedef struct Elem Elem;

typedef struct xml_tree xml_tree;
typedef struct xml_block xml_block;

#pragma incomplete xml_tree
#pragma incomplete xml_block

enum {
	Fcrushwhite = 1,
	Fstripnamespace = 2,
};

struct Xml {
	Elem *root;			/* root of tree */
	char *doctype;		/* DOCTYPE structured comment, or nil */
	struct {
		xml_tree *root;
		xml_block *active;
		int blksiz;
	} alloc;
};

struct Elem {
	Elem *next;			/* next element at this hierarchy level */
	Elem *child;		/* first child of this node */
	Elem *parent;		/* parent of this node */
	Attr *attrs;		/* linked list of atributes */
	char *name;			/* element name */
	char *pcdata;		/* pcdata following this element */
	int line;			/* Line number (for errors) */
};

struct Attr {
	Attr *next;			/* next atribute */
	Elem *parent;		/* parent element */
	char *name;			/* atributes name (NULL for coments) */
	char *value;		/* atributes value */
};

extern int xml_debug;

Attr *xml_attr(Xml *, Attr **, Elem *, char *, char *);
Elem *xml_elem(Xml *, Elem **, Elem *, char *);
Elem *xml_find(Xml *, Elem *, char *);
void xml_free(Xml *);
char *xml_strdup(Xml *, char *, int);
void *xml_calloc(Xml *, long, long);
void *xml_malloc(Xml *, int);
void _xml_heapstats(void);
void _xml_heapfree(Xml *);
Elem *xml_look(Elem *, char *, char *, char *);
Xml *xml_new(int);
Xml *xml_parse(int, int, int);
void xml_print(Xml *, int);
char *xml_value(Elem *, char *);
