#include <u.h>
#include <libc.h>
#include "xml.h"

Attr *
xml_attr(Xml *xp, Attr **root, Elem *parent, char *name, char *value)
{
	Attr *ap, *t;

	USED(xp);
	if((ap = xml_calloc(xp, sizeof(Attr), 1)) == nil)
		sysfatal("no memory - %r\n");
	if(*root == nil){
		*root = ap;
	}
	else{
		for (t = *root; t->next; t = t->next)
			continue;
		t->next = ap;
	}
	ap->parent = parent;

	if(name)
		if((ap->name = xml_strdup(xp, name, 1)) == nil)
			sysfatal("no memory - %r\n");

	if(value)
		if((ap->value = xml_strdup(xp, value, 0)) == nil)
			sysfatal("no memory - %r\n");
	return ap;
}
